
#pragma once
#include <windows.h>

class HookTemplate {
public:
	virtual ~HookTemplate(){}; 
	virtual LPCSTR DLLName() = 0;
	void LoadDLL(char* dllname,HANDLE hDP, DEBUG_EVENT* pde);
	virtual DWORD HandleBreakPoint(HANDLE hDP,DEBUG_EVENT* pde) = 0;
protected:
	virtual void LoadDLL_sub(char* dllname,HANDLE hDP, DEBUG_EVENT* pde) = 0;
	LONG_PTR GetFunctionRelAddr(LPCSTR dllname,LPCSTR funcname);
	LONG_PTR _baseaddr;
	MEMORY_BASIC_INFORMATION _mbi;

};

enum D3D9_BP_state {
	BP_D3DC,
	BP_D3DC_ret,
	BP_D3DC_dev,
};

//NTDLL.dll̃fobO|Cg𖳎邽
class Ntdll_Hook : public HookTemplate {
public:
	virtual LPCSTR DLLName();
	virtual void LoadDLL_sub(char* dllname,HANDLE hDP, DEBUG_EVENT* pde);
	virtual DWORD HandleBreakPoint(HANDLE hDP,DEBUG_EVENT* pde);
private:
	LONG_PTR _lpDbg;
};

class D3D9_Hook : public HookTemplate {
public:
	D3D9_Hook() :  _state(BP_D3DC), _lpD3DC(0) { _bp.addr = 0;};

	virtual LPCSTR DLLName();
	virtual void LoadDLL_sub(char* dllname,HANDLE hDP, DEBUG_EVENT* pde);
	virtual DWORD HandleBreakPoint(HANDLE hDP,DEBUG_EVENT* pde);
private:
	void ProcCreateDevice(HANDLE hDP, DEBUG_EVENT* pde, CONTEXT* pcon);
	LONG_PTR _lpD3DC;
	BreakPoint _bp;
	D3D9_BP_state _state;
};

